indexing

	description: "Stores multipart MIME body."

	author: "Berend de Boer"
	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #1 $"

class

	EPX_MIME_BODY_MULTIPART


inherit

	EPX_MIME_BODY


creation

	make


feature {NONE} -- Initialization

	make is
		do
			create parts.make
		end


feature -- Queries

	is_multipart: BOOLEAN is
		do
			Result := True
		end

	parts_count: INTEGER is
		-- The number of parts if is_multipart.
		do
			Result := parts.count
		end

	part (index: INTEGER): EPX_MIME_PART is
			-- Part number `index' if this is a multipart body.
		do
			Result := parts.item (index)
		end



feature -- State

	parts: DS_LINKED_LIST [EPX_MIME_PART]


feature -- New parts

	new_part: EPX_MIME_PART is
		do
			create Result.make_empty
			parts.put_last (Result)
		ensure
			part_returned: Result /= Void
			one_part_added: parts.count = old parts.count + 1
			result_is_added_part: parts.has (Result)
		end


invariant

	has_parts: parts /= Void
	parts_count_in_sync: parts_count = parts.count

end
